﻿using dotnetSHIP;
using Microsoft.Extensions.Primitives;
using System.Text;

namespace dotnetshipSamples.Pages
{
    public class CanadaPostModel : ShippingPage
    {
        public CanadaPostModel(IConfiguration config) : base(config)
        {
        }
        public void OnGet()
        {
            Ship objShip = new Ship(HttpContext);
            //objShip.CanadaPostLogin = "YourMerchantCPCID";//Don't set for testing.

            objShip.OrigStateProvince = "BC";
            objShip.OrigCountry = "CA";
            objShip.OrigZipPostal = "v5j3y8";

            objShip.DestStateProvince = "CA";
            objShip.DestCountry = "US";
            objShip.DestZipPostal = "90210";

            objShip.Weight = 1;            

            objShip.Rate("CanadaPost");
            StringBuilder resultMessage = new StringBuilder();
            if (!string.IsNullOrEmpty(objShip.Error)) { resultMessage.Append("<br> Error:"); resultMessage.Append(objShip.Error); };

            if (!string.IsNullOrEmpty(objShip.Message)) { resultMessage.Append("<br> Message:"); resultMessage.Append(objShip.Message); };

            if (resultMessage.Length > 0)
                shippingMessage = resultMessage.ToString();
            else
                shippingRates = objShip.DisplayRates("combo", "Rates", " %company% %name% %charge% (%shipdate%)");//Other option for first parameter: "radio"
        }
        public void OnPost()
        {
            StringValues selectedShipping;
            Request.Form.TryGetValue("Rates", out selectedShipping);
            if (!StringValues.IsNullOrEmpty(selectedShipping))
            {
                string[] SelectedRate = selectedShipping.ToString().Split(',');
                shippingSelectedRate = "You selected " + SelectedRate[0] + " " + SelectedRate[1] + SelectedRate[2];
            }
        }

    }
}