﻿using dotnetSHIP;
using Microsoft.Extensions.Primitives;
using System.Text;

namespace dotnetshipSamples.Pages
{
    public class DHLModel : ShippingPage
    {
        public DHLModel(IConfiguration config) : base(config)
        {
        }
        public void OnGet()
        {
            Ship objShip = new Ship(HttpContext);
            //objShip.DHLLogin = "userName,passWord,customerNumber,domesticShippingKey,internationalShippingKey";             

            objShip.OrigZipPostal = "11496";
            objShip.OrigStateProvince = "FL";
            objShip.OrigCountry = "US";

            objShip.DestCountry = "US";
            objShip.DestStateProvince = "WA";
            objShip.DestZipPostal = "98107";

            objShip.Weight = 1;

            objShip.Custom.Company = "MyCompany";
            objShip.Custom.Name = "CustomShip";
            objShip.Custom.Formula = "0-=5;";
            objShip.Custom.ShipTime = "3 Days";
            objShip.Customs.Add();

            objShip.RateBackup = "DHL=MyCompany";


            objShip.Rate("DHL");
            StringBuilder resultMessage = new StringBuilder();
            if (!string.IsNullOrEmpty(objShip.Error)) { resultMessage.Append("<br> Error:"); resultMessage.Append(objShip.Error); };
            if (!string.IsNullOrEmpty(objShip.Message)) { resultMessage.Append("<br> Message:"); resultMessage.Append(objShip.Message); };
            shippingMessage = resultMessage.ToString();

            foreach (Rate rate in objShip.Rates)
                shippingRates += "Company: " + rate.Company + ", Name:" + rate.Name + ", Charge: $" + rate.Charge + ", ShipTime:" + rate.ShipTime + "<br>";
        }
        public void OnPost()
        {
            StringValues selectedShipping;
            Request.Form.TryGetValue("Rates", out selectedShipping);
            if (!StringValues.IsNullOrEmpty(selectedShipping))
            {
                string[] SelectedRate = selectedShipping.ToString().Split(',');
                shippingSelectedRate = "You selected " + SelectedRate[0] + " " + SelectedRate[1] + SelectedRate[2];
            }
        }
    }
}