﻿using dotnetSHIP;
using Microsoft.Extensions.Primitives;
using System.Text;

namespace dotnetshipSamples.Pages
{
    public class EasyPostModel : ShippingPage
    {
        public EasyPostModel(IConfiguration config) : base(config)
        {
        }
        public void OnGet()
        {
            Ship objShip = new Ship(HttpContext);
            objShip.EasyPostLogin = "8HtJ3dCOfWdTLJyBYiyg"; //Set to your EasyPost account API key

            objShip.OrigName = "Your Company Name"; //Required for generating label
            objShip.OrigAddress = "164 Townsend";
            objShip.OrigCity = "San Francisco";
            objShip.OrigZipPostal = "94107";
            objShip.OrigStateProvince = "CA";
            objShip.OrigCountry = "US";

            objShip.DestName = "Brian Anderson";
            objShip.DestAddress = "179 N Harbor Dr";
            objShip.DestCity = "Redondo Beach";
            objShip.DestStateProvince = "CA";
            //objShip.DestZipPostal = "90277";
            objShip.DestZipPostal = "12345";
            objShip.DestCountry = "US";

            objShip.Weight = 3;
            //objShip.UPSPack = "UPSExpressBox";
            //objShip.USPSPack = "LargeParcel";
            objShip.Length = 3;
            objShip.Height = 2;
            objShip.Width = 4;

            objShip.Custom.Company = "MyCompany";
            objShip.Custom.Name = "CustomShip";
            objShip.Custom.Formula = "0-=5;";
            objShip.Customs.Add();

            objShip.RateBackup = "EASYPOST=MyCompany";

            objShip.Rate("EASYPOST"); //UPS: ca_Pbnku4uG , USPS: ca_BdYsfUdp
            StringBuilder resultMessage = new StringBuilder();
            if (!string.IsNullOrEmpty(objShip.Error)) { resultMessage.Append("<br> Error:"); resultMessage.Append(objShip.Error); };
            if (!string.IsNullOrEmpty(objShip.Message)) { resultMessage.Append("<br> Message:"); resultMessage.Append(objShip.Message); };          
            
            if (resultMessage.Length > 0)
                shippingMessage = resultMessage.ToString();
            else
                shippingRates = objShip.DisplayRates("combo", "Rates", " %company% %name% %charge% (%shipdate%)");//Other option for first parameter: "radio"
            //foreach (Rate rate in objShip.Rates)
            //    resultMessage.Append("<br/>ID: " + rate.ID + ", Company: " + rate.Company + ", Name:" + rate.Name + ", Charge: " + rate.Charge + ", ShipTime: " + rate.ShipTime);
        }
        public void OnPost()
        {
            StringValues selectedShipping;
            Request.Form.TryGetValue("Rates", out selectedShipping);
            if (!StringValues.IsNullOrEmpty(selectedShipping))
            {
                string[] SelectedRate = selectedShipping.ToString().Split(',');
                shippingSelectedRate = "You selected " + SelectedRate[0] + " " + SelectedRate[1] + SelectedRate[2];
            }
        }

    }
}