﻿using dotnetSHIP;
using System.Text;

namespace dotnetshipSamples.Pages
{
    public class RoadwayModel : ShippingPage
    {
        public RoadwayModel(IConfiguration config) : base(config)
        {
        }
        public void OnGet()
        {
             Ship objShip = new Ship(HttpContext);
            //Roadway is a freight shipping provider suitable for very large and heavy items
            //While you require an account to ship with roadway, no login is required as the public rating interface is used.
            objShip.OrigCity = "Lompoc";
            objShip.OrigZipPostal = "93436";
            objShip.OrigCountry = "US";
            objShip.OrigStateProvince = "CA";

            objShip.DestCity = "Vancouver";
            objShip.DestStateProvince = "BC";
            objShip.DestZipPostal = "v5v1y9";
            objShip.DestCountry = "CA";



            objShip.Weight = 500;


            objShip.Rate("Roadway");
            StringBuilder resultMessage = new StringBuilder();
            if (!string.IsNullOrEmpty(objShip.Error)) { resultMessage.Append("<br> Error:"); resultMessage.Append(objShip.Error); };
            if (!string.IsNullOrEmpty(objShip.Message)) { resultMessage.Append("<br> Message:"); resultMessage.Append(objShip.Message); };
            shippingMessage = resultMessage.ToString();

            foreach (Rate rate in objShip.Rates)
                shippingRates += "Company: " + rate.Company + ", Name:" + rate.Name + ", Charge: $" + rate.Charge + ", ShipTime:" + rate.ShipTime + "<br>";
        }
        
    }
}