﻿using dotnetSHIP;
using Microsoft.Extensions.Primitives;
using System.Text;

namespace dotnetshipSamples.Pages
{
    public class UPSModel : ShippingPage
    {
        public UPSModel(IConfiguration config) : base(config)
        {
        }

        public void OnGet()
        {
            Ship objShip = new Ship(HttpContext);
            objShip.UPSLogin = "YourUserID,YourPassWord,YourAccessCode"; //userName,passwrod, accesscode            

            objShip.OrigCountry = "US";
            objShip.OrigZipPostal = "07307";
            objShip.OrigStateProvince = "NJ";

            objShip.DestZipPostal = "93436";
            objShip.DestCountry = "USA";
            objShip.DestStateProvince = "CA";

            objShip.Weight = 10;          
           
            objShip.Rate("UPS");
            StringBuilder resultMessage = new StringBuilder();
            if (!string.IsNullOrEmpty(objShip.Error)) { resultMessage.Append("<br> Error:"); resultMessage.Append(objShip.Error); };
            if (!string.IsNullOrEmpty(objShip.Message)) { resultMessage.Append("<br> Message:"); resultMessage.Append(objShip.Message); };

            if (resultMessage.Length > 0)
                shippingMessage = resultMessage.ToString();
            else
                shippingRates = objShip.DisplayRates("combo", "Rates", " %company% %name% %charge% (%shipdate%)");//Other option for first parameter: "radio"
        }
        public void OnPost()
        {
            StringValues selectedShipping;
            Request.Form.TryGetValue("Rates", out selectedShipping);
            if (!StringValues.IsNullOrEmpty(selectedShipping))
            {
                string[] SelectedRate = selectedShipping.ToString().Split(',');
                shippingSelectedRate = "You selected " + SelectedRate[0] + " " + SelectedRate[1] + SelectedRate[2];
            }
        }

    }
}