﻿using dotnetSHIP;
using Microsoft.Extensions.Primitives;
using System.Text;

namespace dotnetshipSamples.Pages
{
    public class USPSModel : ShippingPage
    {
        public USPSModel(IConfiguration config) : base(config)
        {
        }
        public void OnGet()
        {
            Ship objShip = new Ship(HttpContext);
            objShip.USPSLogin = "YourUserName,YourPassWord";

            objShip.OrigCountry = "US";
            objShip.OrigZipPostal = "07307";
            objShip.OrigStateProvince = "NJ";

            objShip.DestZipPostal = "93436";
            objShip.DestCountry = "US";
            objShip.DestStateProvince = "CA";           

            objShip.Weight = 2;
            objShip.Custom.Company = "MyCompany";
            objShip.Custom.Name = "CustomShip";
            objShip.Custom.Formula = "0-=5;";
            objShip.Customs.Add();
            
            objShip.Rate("USPS");
            StringBuilder resultMessage = new StringBuilder();
            if (!string.IsNullOrEmpty(objShip.Error)) { resultMessage.Append("Error: "); resultMessage.Append(objShip.Error); };
            if (!string.IsNullOrEmpty(objShip.Message)) { resultMessage.Append(" Message: "); resultMessage.Append(objShip.Message); };

            if (resultMessage.Length > 0)
                shippingMessage = resultMessage.ToString();
            else
                shippingRates = objShip.DisplayRates("combo", "Rates", " %company% %name% %charge% (%shipdate%)");//Other option for first parameter: "radio"
        }      
        public void OnPost()
        {
            StringValues selectedShipping;
            Request.Form.TryGetValue("Rates", out selectedShipping);
            if (!StringValues.IsNullOrEmpty(selectedShipping))
            {
                string[] SelectedRate = selectedShipping.ToString().Split(',');
                shippingSelectedRate = "You selected " + SelectedRate[0] + " " + SelectedRate[1] + SelectedRate[2];
            }
        }

    }
}