<%@ Page Language="C#" Debug="true" %>

<script runat="server">  
    string EasyPostKeyAPI = "8HtJ3dCOASfWdJyBYiyg"; //Set to your EasyPost account API key
    string printlabelUrl = "";
    string shipmentID = "";
    string labelFormat = "";
    string rateID = "";
    void Page_Load(Object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            shipmentID = Request.Params["ShipmentID"];
            labelFormat = Request.Params["LabelFormat"];
            string selectedRate = Request.Params["ComboRates"];
            if (!string.IsNullOrEmpty(selectedRate))
                rateID = selectedRate.Split(',')[4];
            if (string.IsNullOrEmpty(shipmentID) || string.IsNullOrEmpty(rateID))
            {
                Response.Write("Please use EasyPost.aspx page or set shipmentID and RateID before calling GetLabel method.");
                return;
            }
            else
            {
                CreateOrGetLabel(shipmentID, labelFormat, rateID);
            }
        }

    }
    void GetLable_Click(Object sender, EventArgs e)
    {
        string commandArgument = ((Button)sender).CommandArgument;
        if (!string.IsNullOrEmpty(commandArgument))
        {
            shipmentID = commandArgument.Split('&')[0];
            labelFormat = commandArgument.Split('&')[1];
        }
        if (string.IsNullOrEmpty(shipmentID))
        {
            Response.Write("Please use EasyPost.aspx page or set shipmentID  before calling GetLabel.");
            return;
        }
        else
        {
            ServiceLabel.Controls.Clear();
            CreateOrGetLabel(shipmentID, labelFormat, "");           
        }
    }
    void CreateOrGetLabel(string shipID, string format, string selectedRate)
    {
        bool result = false;
        dotnetSHIP.Ship objShip = new dotnetSHIP.Ship();       
        objShip.EasyPostLogin = EasyPostKeyAPI;
        if (!string.IsNullOrEmpty(selectedRate))
        {
            result = objShip.GetLabel(shipmentID, rateID, labelFormat);            
        }
        else
        {
            result = objShip.GetLabel(shipmentID, labelFormat);
        }        
        if (result)
        {
            shipmentID = objShip.EasyPostShipmentID;
            if (labelFormat == "pdf")
            {
                ServiceLabel.Controls.Add(new LiteralControl("<embed width='800px' height='1200px' src='" + objShip.Label.URL + "' >"));
                printlabelUrl = "printIt('<embed width=\\\'600px\\\' height=\\\'900px\\\' src=\\\'" + objShip.Label.URL + "\\\'>')";                
                GetLabel.Text = "Get PNG Format";
                GetLabel.CommandArgument = shipmentID + "&png";
            }
            else
            {
                ServiceLabel.Controls.Add(new LiteralControl("<img width='800px' height='1200px' src='" + objShip.Label.URL + "' >"));
                printlabelUrl = "printIt('<img width=\\\'600px\\\' height=\\\'900px\\\' src=\\\'" + objShip.Label.URL + "\\\'>')";
                GetLabel.Text = "Get PDF Format";
                GetLabel.CommandArgument = shipmentID + "&pdf";
            }
        }
        else
        {
            Response.Write("<br/>Error:" + objShip.Error);
        }
    }
</script>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>.netSHIP EasyPost Label</title>
    <script type="text/javascript">
        function printIt(printThis) {      
           try{             
                var win = window.open("");
                self.focus();
                win.document.open();
                win.document.write('<' + 'html' + '><' + 'body' + '>');
                win.document.write(printThis);
                win.document.write('<' + '/body' + '><' + '/html' + '>');
                win.document.close();
                win.onload = function () {
                    win.print();
                    win.close();
                }
            }
            catch(err) {
                alert("Error: " + err + " Sorry, please refresh the page and try again.");
            }
        }
    </script>
</head>
<body>
    <form id="Form1" method="post" runat="server">
    <table>
        <tr>
            <td align="center" colspan="1">
                <input type="button" id="PrintThisLabel" onclick="<%= printlabelUrl %>" value="Print This Label" />
            </td>
            <td align="center" colspan="1">
                <asp:Button ID="GetLabel" runat="server" OnClick="GetLable_Click" Text="Get PDF Format" />
            </td>
            <td align="center" colspan="1">
                <asp:Button ID="CreateNewLable" runat="server" PostBackUrl="EasyPost.aspx"
                    Text="Create a New Label" />
            </td>
        </tr>
        <tr>
            <td align="center" colspan="3">
                <hr />
            </td>
        </tr>
        <tr>
            <td align="center" colspan="3">
                <asp:PlaceHolder ID="ServiceLabel" Visible="true" runat="server"></asp:PlaceHolder>
            </td>
        </tr>
    </table>
    </form>
</body>
</html>
