<%@ Page Language="VB" Debug="true" %>

<script runat="server">  

    Private EasyPostKeyAPI As String = "8HtJ3dCOASTLJyBYiyg" 'Set to your EasyPost account API key

Private printlabelUrl As String = ""
Private shipmentID As String = ""
Private labelFormat As String = ""
Private rateID As String = ""
Private Sub Page_Load(sender As [Object], e As EventArgs)
	If Not IsPostBack Then
		shipmentID = Request.Params("ShipmentID")
		labelFormat = Request.Params("LabelFormat")
		Dim selectedRate As String = Request.Params("ComboRates")
		If Not String.IsNullOrEmpty(selectedRate) Then
			rateID = selectedRate.Split(","C)(4)
		End If
		If String.IsNullOrEmpty(shipmentID) OrElse String.IsNullOrEmpty(rateID) Then
			Response.Write("Please use EasyPost.aspx page or set shipmentID and RateID before calling GetLabel method.")
			Return
		Else
			CreateOrGetLabel(shipmentID, labelFormat, rateID)
		End If
	End If

End Sub
Private Sub GetLable_Click(sender As [Object], e As EventArgs)
	Dim commandArgument As String = DirectCast(sender, Button).CommandArgument
	If Not String.IsNullOrEmpty(commandArgument) Then
		shipmentID = commandArgument.Split("&"C)(0)
		labelFormat = commandArgument.Split("&"C)(1)
	End If
	If String.IsNullOrEmpty(shipmentID) Then
		Response.Write("Please use EasyPost.aspx page or set shipmentID  before calling GetLabel.")
		Return
	Else
		ServiceLabel.Controls.Clear()
		CreateOrGetLabel(shipmentID, labelFormat, "")
	End If
End Sub
Private Sub CreateOrGetLabel(shipID As String, format As String, selectedRate As String)
	Dim result As Boolean = False
        Dim objShip As New dotnetSHIP.Ship()
	objShip.EasyPostLogin = EasyPostKeyAPI
	If Not String.IsNullOrEmpty(selectedRate) Then
            result = objShip.GetLabel(shipmentID, rateID, labelFormat)
	Else
		result = objShip.GetLabel(shipmentID, labelFormat)
        End If
        If result Then
            shipmentID = objShip.EasyPostShipmentID
            If labelFormat = "pdf" Then
                ServiceLabel.Controls.Add(New LiteralControl("<embed width='800px' height='1200px' src='" + objShip.Label.URL + "' >"))
                printlabelUrl = "printIt('<embed width=\'800px\' height=\'1200px\' src=\'" + objShip.Label.URL + "\'>')"
                GetLabel.Text = "Get PNG Format"
                GetLabel.CommandArgument = shipmentID & Convert.ToString("&png")
            Else
                ServiceLabel.Controls.Add(New LiteralControl("<img width='800px' height='1200px' src='" + objShip.Label.URL + "' >"))
                printlabelUrl = "printIt('<img width=\'800px\' height=\'1200px\' src=\'" + objShip.Label.URL + "\'>')"
                GetLabel.Text = "Get PDF Format"
                GetLabel.CommandArgument = shipmentID & Convert.ToString("&pdf")
            End If
        Else
            Response.Write("<br/>Error:" + objShip.[Error])
        End If
End Sub
</script>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>.netSHIP EasyPost Label</title>
   <script type="text/javascript">
       function printIt(printThis) {
           try {
               var win = window.open("");
               self.focus();
               win.document.open();
               win.document.write('<' + 'html' + '><' + 'body' + '>');
               win.document.write(printThis);
               win.document.write('<' + '/body' + '><' + '/html' + '>');
               win.document.close();
               win.onload = function () {
                   win.print();
                   win.close();
               }
           }
           catch (err) {
               alert("Error: " + err + " Sorry, please refresh the page and try again.");
           }
       }
    </script>
</head>
<body>
    <form id="Form1" method="post" runat="server">
    <table>
        <tr>
            <td align="center" colspan="1">
                <input type="button" id="PrintThisLabel" onclick="<%= printlabelUrl %>" value="Print This Label" />
            </td>
            <td align="center" colspan="1">
                <asp:Button ID="GetLabel" runat="server" OnClick="GetLable_Click" Text="Get PDF Format" />
            </td>
            <td align="center" colspan="1">
                <asp:Button ID="CreateNewLable" runat="server" PostBackUrl="EasyPost.aspx"
                    Text="Create a New Label" />
            </td>
        </tr>
        <tr>
            <td align="center" colspan="3">
                <hr />
            </td>
        </tr>
        <tr>
            <td align="center" colspan="3">
                <asp:PlaceHolder ID="ServiceLabel" Visible="true" runat="server"></asp:PlaceHolder>
            </td>
        </tr>
    </table>
    </form>
</body>
</html>
